float Script : STANDARDSGLOBAL <
    string   UiControl = "none";
    string   ScriptClass = "scene";
    string   ScriptOrder = "standard";
    string   ScriptOutput = "colour";
    string   Script = "Technique=Spherical_Map;";
    string   ScriptDescription = "<b>Spherical map skybox</b>";
> = 0.1; // version #

float envExposure
<
    string   UiName = "Env Exposure";
    string   UiControl = "Slider";
   float UiMin = -10.0f;
   float UiMax = 10.0f;
 > = 1;
 
float envRotation
<
    string   UiName = "Env Rotation";
    string   UiControl = "Slider";
   float UiMin = 0.0f;
   float UiMax = 360.0f;
 > = 0;

sampler2D tex0 <  string BindAddress = "Tog.Texture[0].2D"; >;			///environment

const float M_INV_PI = 0.31830988618379067153776752674503;

struct App2vert
{
	float3 position : POSITION;
	float3 normal : NORMAL;
};

struct Vert2frag
{
	float4 hpos : POSITION;
	float3 normal : TEXCOORD7;
};

Vert2frag vertex_main(
	App2vert vs_in)
{
	Vert2frag vs_out;
	float4 position = float4(vs_in.position, 1);
	//WVP * position
	vs_out.hpos = mul(glstate.matrix.mvp, position);
	//normal
	vs_out.normal = normalize(vs_in.normal);
	return vs_out;
}

typedef float4 FS_OUT;

float3 envSample(
	float3 dirWS){
	
	//spherical mapping
	float n = length(dirWS.xz);
	float2 pos = float2( (n>0.0000001) ? dirWS.x / n : 0.0, dirWS.y);
	pos = acos(pos)*M_INV_PI;
	pos.x = (dirWS.z > 0.0) ? pos.x*0.5 : 1.0-(pos.x*0.5);
	pos.x += envRotation;
	pos.y = 1.0-pos.y;

	float3 hdrSample = tex2D(tex0, pos).rgb * pow(2, envExposure);
	return hdrSample;
}

FS_OUT fragment_main(
	Vert2frag fs_in) : COLOR
{
	FS_OUT fs_out;
	fs_out = float4(pow(envSample(fs_in.normal), (1 / 2.2)), 1);
	return fs_out;
}

technique Spherical_Map
{
	pass P0
	{
		VertexShader = compile vp40 vertex_main();
		PixelShader  = compile gp4fp fragment_main(); // gp4fp
	}
}

// string descriptionTest = "PBRTestConversion";